      subroutine frtsv (ncl, jx)
c  Single direct run of the model.  A. Kuusk 3.03.2025
c
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c     
      save sntr, tlai, tbai, uuz, nzs, rty, tlaief, efflai, 
     & ggsu, ggvu, 
     & rleff, tleff, tlty, rdsgrou, rsdgrou, rddgrou, 
     & bqc1, bqg1, bqm, rteff, tteff, jwl
c
      dimension pslvu(nclmax), pslvd(nclmax), pstru(nclmax), 
     & pstrd(nclmax)
      dimension uuz(nzmax)
c
      ijob    = i_job
      nzs     = n_zs
      if (ijob .eq. 0) then
        jbnd  = 1
        jview = 1
      endif
      if (ijob .eq. 1 .or. ijob .gt. 2) then
        if (lopt) then
          jview = 1
          jbnd  = jx
        else
          jbnd = 1
          jview = jx
        endif
      endif
      if (ijob .eq. 2) then
        jbnd  = 1
      endif
      rlambda = wlarr(jbnd)
      jwl     = nint((rlambda - (400.d0 - wlstep))/wlstep)
c
      if (jpass .eq. 0) then
        do j = 1, 19
          x_m(j) = -99.d0
        enddo
      endif
c
      if (lstruc) then
        call strmean
     & (ncl, ths, thv, sntr, htrmn, htrmax, crhmn, cilhmn, 
     & zcctr, cmean, crrmn, dbhmn, shlm, cshm, rirm, dcmn, acmn, 
     & crcl, cacl, tmass, slwm, efflai, tlty, tlaief, tlai, tbai, 
     & utot, uuz, thmm, ggsu, ggvu, ggmean, tsst, tsvt)
        if (jpass .eq. 0) then
          x_m(1)  = sntr
          x_m(2)  = htrmn
          x_m(3)  = crhmn
          x_m(4)  = cilhmn
          x_m(5)  = crrmn
          x_m(6)  = dbhmn*100.d0
          x_m(7)  = tmass
          x_m(8)  = slwm
          x_m(10) = thmm/dr
          x_m(11) = shlm
          x_m(12) = tbai/tlaief
          x_m(13) = clmpst
          x_m(15) = cshm
          x_m(16) = rirm
          t_lai   = tlai
        endif
c                              ! calculation of probabilities
        call hetk8s
     & (ncl, ths, thv, phi, nzs, sntr, zcctr, cmean, crrmn, dbhmn, 
     & ggsu, ggvu, utot, aas, aavj, psgrj, pslvu, pslvd, pstru, pstrd)
        aav(jview) = aavj
        p11gr(jview)  = psgrj
        sum1 = 0.d0
*       sum2 = 0.d0
        sum3 = 0.d0
*       sum4 = 0.d0
        do jcl = 1, ncl
          sum1 = sum1 + pslvu(jcl)
*         sum2 = sum2 + pslvd(jcl)
          sum3 = sum3 + pstru(jcl)
*         sum4 = sum4 + pstrd(jcl)
        enddo
        p11lvs(jview) = sum1
        p11tr(jview)  = sum3
c
        do j = 1, ncl
          u_uu(j) = uuu(j)
        enddo
c              if ijob=0 provide the vertical profile of foliage
        if (ijob .eq. 0) then
          do j = 1, 400
             u_uz(j) = uuz(j)
          enddo
        endif
      endif
c
      if (lopt) then
c                               ! Mean optical parameters
        call optmean
     & (ncl, jwl, tlty, tbai, tlaief, rleff, tleff, rty, 
     & rteff, tteff, rneff)
c
        r_leff  = rleff
        t_leff  = tleff
        r_neff  = rneff
      endif
c
c            ! Albedo of ground vegetation is calculated 
c            ! integrating ACRM in perpendicular plane, phi = pi/2
c
      phisave = phi
      phi     = pi/2.d0
      thvsave = thv
c
      call aground
     & (rsogrou, rdsgrou, rsdgrou, rddgrou)
c                             ! rddgrou = albedo of ground vegetation
      phi = phisave
      thv = thvsave
c
      call hetk8o
     & (ncl, jwl, ths, thv, phi, stdns, eln3, thm3, ghg, 
     & pslvu, pslvd, pstru, pstrd, pkhair, rnlf, rtrnk, bqc1, bc1d)
c
c
c                                     S'/Q - direct to diffuse ratio
      sq = sqa(jwl)
      skyl  = 1.d0 - sq
c                                     diffuse fluxes of tree crowns
      call diffor
     & (ths, thv, skyl, efflai, tlty, ggmean, 
     & tsst, tsvt, rleff, tleff, 
     & rdsgrou, rsdgrou, rddgrou, budif, bddif)
c
c
c               ! reflectance of ground vegetation r??grou was calculated
c               ! with 2-layer model ACRMf
c
      skylg = bddif/(aas*cos(ths)*pi + bddif)
c  bddif is diffuse downward flux under tree layer
c
      thets = ths
      thetv = thv
      call smcrm
     &  (thets, thetv, penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 - skylg)*(bc1 + bs1) + bdplants + bdsoil
c
      br1gr    = sbgr*psgrj
c
      b0       = bqc1 + br1gr
      bqq     = sq*b0 + budif
*          write (0, *) thv/dr, budif
c                                          reflectance components
      bqg1 = sq*br1gr
      bqm  = budif
*           write (*, '(f10.1, 3f10.5)')
*    &  thv/dr, bqc1, br1gr, budif
c                                                  radiance down
      bdwnj = (bc1d + bddif) + aav(jview)/pi*skyl
*        print *, thv/dr,
*    & bsngld, bddif, aav/pi*skyl, bdown(j_sun)
c
      if (ijob .le. 1) then
        lopt = .true.
        jwl   = nint((rlambda - (400.d0 - wlstep))/wlstep)
        skyl  = 1.d0 - sq
        thets = ths
        thetv = thv
        call smcrm
     &  (thets, thetv, penalty, bc1, bs1, bdplants, bdsoil)
        sbgr = sq*(bc1 + bs1) + bdplants + bdsoil
        sq = 1.d0 - skyl
        rth(jbnd)   = bqq
        rsth(jbnd)  = sbgr
        rcr1(jbnd)  = bqc1
        rgr1(jbnd)  = bqg1
        rdif(jbnd)  = bqm
        bdown(jbnd) = bdwnj
        if (mod(jbnd, 10) .eq. 0)
     &    write (0, '(f8.1, g16.5)') wlarr(jbnd), rth(jbnd)
      endif
c
      if (ijob .eq. 2) then
        rth(jview)   = bqq
        rsth(jview)  = sbgr
        rcr1(jview)  = bqc1
        rgr1(jview)  = bqg1
        rdif(jview)  = bqm
        bdown(jview) = bdwnj
        lstruc = .true.
*        write (*, '(f6.1, 4f10.5)')
*    &         thv/dr, bsngld, bddif, aav, bdwnj
      endif
c
      if (ijob .lt. 2 .and. jview .eq. 1) then
c                            Output results ijob=0
        jx = jbnd
      else
        jx = jview
      endif
        rth(jx)   = bqq
        rsth(jx)  = sbgr
        rcr1(jx)  = bqc1
        rgr1(jx)  = bqg1
        rdif(jx)  = bqm
        bdown(jx) = bdwnj
c
      return
      end
*
************************************************************************
*
