      subroutine pstem
     & (lellj, nzs, sntr, htrj, hc1j, hc2j, rcrj, dbhj, zcctr, 
     & cmean, crrmn, dbhmn, ggsu, ggvu, utot, glmp, ths, thv, phi,
     & sths, cths, sthv, cthv, calph, p2truj, p2trdj)
c                    Probability of sunlit stem    A. Kuusk 5.03.2024
c
      include 'par.h'
      include 'volint.h'
      data eps/.001d0/
c
      ntstz   = 2*nzs
      hcrj   = hc1j + hc2j
      cell    = hcrj/2.d0
      a2 = rcrj**2
      htrmax = zcctr + cmean
c
      p2tru = 0.d0
      p2trd = 0.d0
      utyu  = 0.d0
      utyd  = 0.d0
c                       zvari - the height of the crown shadow
      tgths = sths/cths
      tgthx = max(tgths, eps)
      if (lellj) then
         zv = sqrt(a2 + (cell*tgths)**2)/tgthx          
      else
         zv = rcrj/tgthx
      endif
      zvari = htrj - hcrj - zv
c
      if (zvari .gt. 0.d0) then
        if (thv .lt. ths) then
          tgthv = sthv/cthv
          tgthx = max(tgthv, eps)
          if (lellj) then
             xxx = sqrt(a2 + (cell*tgthv)**2)
             zv = xxx/tgthx
          else
             zv = rcrj/tgthx
          endif
          zview = max(zvari, 0.d0)
        else
          zview = zvari
        endif
c
c                       ! uty - the area of sunlit stem
        utyd = dbhj*pi/2.d0*zvari
        utyu = dbhj*pi/2.d0*zview
c                              ! the integral of pooi over [0, zvari]
        dzenel = hcrj/ntstz
        if (zvari .le. dzenel) then
          dztrnk = zvari
        else
          dztrnk = dzenel
        endif
        nz = int(zvari/dztrnk + .5d0)
        nz1 = nz + 1
        nview = int(zview/dztrnk + .5d0) + 1
        dztrnk = zvari/nz
c
        if (nview .lt. nz) then
          do k = 1, nz1
            zk   = (k - 1)*dztrnk
            z2   = zk
            z3   = zk
c
            if (zk .ge. htrmax .and. z2 .ge. htrmax) then
              poouj = 1.d0
            else
              call bgf2
     &        (sntr, zcctr, cmean, crrmn, dbhmn, 
     &        ggsu, ggvu, utot, glmp, zk, z2, z3, sths, cths, 
     &        sthv, cthv, calph, poouj, poodj)
            endif
c
            if (k .eq. 1 .or. k .eq. nz1) poodj = poodj/2.d0
            p2trd = p2trd + poodj
            if (k .eq. 1 .or. k .eq. nview) poouj = poouj/2.d0
            if (k .le. nview) p2tru = p2tru + poouj
          enddo
          p2trd = p2trd/nz
          p2tru = p2tru/nview
        else
          do k = 1, nz1
            zk   = (k - 1)*dztrnk
            z2   = zk
            z3   = zk
c
            if (zk .ge. htrmax .and. z2 .ge. htrmax) then
              poouj = 1.d0
            else
              call bgf2
     &        (sntr, zcctr, cmean, crrmn, dbhmn, 
     &        ggsu, ggvu, utot, glmp, zk, z2, z3, sths, cths, 
     &        sthv, cthv, calph, poouj, poodj)
            endif
c
            if (k .eq. 1 .or. k .eq. nz1) then
               poodj = poodj/2.d0
               poouj = poouj/2.d0
            endif
            p2trd = p2trd + poodj
            p2tru = p2tru + poouj
c
          enddo
          p2trd = p2trd/nz1
          p2tru = p2tru/nview
        endif
      endif
c
*        write (*, '(f6.1, 4f10.5)') 
*    &         thv/0.0174532925, p2trd, p2tru
c
      p2truj = p2tru*utyu*(pi - phi)/pi*sthv
      p2trdj = p2trd*utyd*(pi - phi)/pi*sthv
c
      return
      end
*
************************************************************************
*
